/**
 * Provides the basic interface for unique, serializable objects.
 */
export class SerializableItem<JSONType, HistoryType> {
    public id: number; // Serialized objects need to be unique.

    constructor(id = 0) {
        this.id = id;
    }

    public toJSONSerializableObject(): JSONType {
        throw new Error(
            "Method 'toJSONSerializableObject()' is not implemented."
        );
    }

    public toHistorySerializableObject(): HistoryType {
        throw new Error(
            "Method 'toHistorySerializableObject()' is not implemented."
        );
    }

    public fromSerializedObject(
        data: JSONType | HistoryType
    ): SerializableItem<JSONType, HistoryType> {
        throw new Error(
            "Method 'fromSerializableObject()' is not implemented."
        );
    }
}
